#!/bin/bash
mkdir -p ${TAR_INSTALL_PATH}/wifi_tools/
mkdir -p ${TAR_INSTALL_PATH}/wifi_tools/bin
mkdir -p ${TAR_INSTALL_PATH}/wifi_tools/lib

export CC=${CROSS_COMPILE}gcc
export NM=${CROSS_COMPILE}nm
export CXX=${CROSS_COMPILE}g++
export LD=${CROSS_COMPILE}ld
export RANLID=${CROSS_COMPILE}ranlib
export AR=${CROSS_COMPILE}ar
STP=${CROSS_COMPILE}'strip'

rm -rf ./athcfg/
tar -zxvf athcfg.tar.gz

rm -rf ./ixchariot/
tar -zxvf ixchariot.tar.gz

rm -rf ./wireless_tools-v29/
tar -zxvf wireless_tools-v29.tar.gz

tar -zxvf wifi_tools_patch.tar.gz

rm -rf ./bridge-utils-1.4/
tar -zxvf bridge-utils-1.4.tar.gz
cd bridge-utils-1.4
make
if [ 0 -ne $? ]; then
    echo "build bridge-utils failed"
    exit 1
fi
cp -af ./brctl/brctl ../

cd ..
cp -af ./brctl ${TAR_INSTALL_PATH}/wifi_tools/bin/
cp -af ./ated ${TAR_INSTALL_PATH}/wifi_tools/bin/

cp -af ./ixchariot ${TAR_INSTALL_PATH}/wifi_tools/bin/
cp -af ./eprun.sh ${TAR_INSTALL_PATH}/wifi_tools/bin/

cp -af athcfg_Makefile.linux ./athcfg/Makefile.linux
cd ./athcfg
make -f Makefile.linux clean
make -f Makefile.linux
if [ 0 -ne $? ]; then
    echo "build athcfg failed"
    exit 1
fi
cp -af ./athcfg ${TAR_INSTALL_PATH}/wifi_tools/bin/

cd ..
rm -rf ./iperf-1.7.0/
tar -xvf iperf-1.7.0-source.tar.gz
cd iperf-1.7.0
cd cfg
./configure --build=i686-pc-linux --host=arm-linux
cd ..
make
if [ 0 -ne $? ]; then
    echo "build iperf-1.7.0 failed"
    exit 1
fi
mv ./iperf ${TAR_INSTALL_PATH}/wifi_tools/bin/iperf_1.7.0

cd ..
rm -rf ./iperf-2.0.4/
tar -xvf iperf-2.0.4-source.tar.gz
cp -af ./iperl-2.0.4-arm-linux.cache ./iperf-2.0.4/arm-linux.cache
cd iperf-2.0.4
./configure --build=i686-pc-linux --host=arm-linux --cache-file=arm-linux.cache --prefix=${TAR_INSTALL_PATH}/wifi_tools
make
if [ 0 -ne $? ]; then
    echo "build iperf-2.0.4 failed"
    exit 1
fi
make install
if [ 0 -ne $? ]; then
    echo "Install iperf-2.0.4 failed"
    exit 1
fi
mv ${TAR_INSTALL_PATH}/wifi_tools/bin/iperf ${TAR_INSTALL_PATH}/wifi_tools/bin/iperf_2.0.4

cd ..
cp -af tools_Makefile ./wireless_tools-v29/Makefile
cd ./wireless_tools-v29
make clean
make
if [ 0 -ne $? ]; then
    echo "build wireless_tools failed"
    exit 1
fi
make install
if [ 0 -ne $? ]; then
    echo "Install wireless_tools failed"
    exit 1
fi
cp -af ./out/sbin/* ${TAR_INSTALL_PATH}/wifi_tools/bin/
cp -af ./out/lib/* ${TAR_INSTALL_PATH}/wifi_tools/lib/

cd ${TAR_INSTALL_PATH}/wifi_tools
mkdir -p usr
mkdir -p usr/local
mv ./lib/ usr/local
mv ./bin/ usr/local
${STP}  ./usr/local/lib/*.s*

cd ./usr/local/bin
ln -sfn iperf_2.0.4 iperf

